// -*- c-basic-offset: 4; tab-width: 8; indent-tabs-mode: t -*-

// Copyright (c) 2001-2003 International Computer Science Institute
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the "Software")
// to deal in the Software without restriction, subject to the conditions
// listed in the XORP LICENSE file. These conditions include: you must
// preserve this copyright notice, and you cannot mention the copyright
// holders in advertising related to the Software without their permission.
// The Software is provided WITHOUT ANY WARRANTY, EXPRESS OR IMPLIED. This
// notice is a summary of the XORP LICENSE file; the license in that file is
// legally binding.

#ident "$XORP: xorp/rip/routed/xorp-rip.cc,v 1.2 2003/03/10 23:20:58 hodson Exp $"

#include "xorp-rip.h"
#include "libxorp/eventloop.hh"

static EventLoop event_loop;

void
xrip_initialize(void)
{
}

void
xrip_main_loop(int blocking_ms)
{
    bool	halt_flag = false;
    XorpTimer	t = event_loop.set_flag_after_ms(blocking_ms, &halt_flag);

    while (halt_flag == false)
	event_loop.run();
}

struct timeval
xrip_idle_period(void)
{
    timeval t;
    if (event_loop.timer_list().get_next_delay(t) == false) {
	t.tv_sec = 1000;
	t.tv_usec = 0;
    }
    return t;
}
